// CHECKSTYLE:OFF
/**
 * Source code generated by Fluent Builders Generator
 * Do not modify this file
 * See generator home page at: http://code.google.com/p/fluent-builders-generator-eclipse-plugin/
 */

package nl.krocket.ocr.core.model.builders;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import nl.krocket.ocr.core.model.Address;
import nl.krocket.ocr.core.model.BaseImage;
import nl.krocket.ocr.core.model.Company;
import nl.krocket.ocr.core.model.ProcesStatus;
import nl.krocket.ocr.core.model.UserInfo;

public class CompanyBuilder extends CompanyBuilderBase<CompanyBuilder> {
	public static CompanyBuilder company() {
		return new CompanyBuilder();
	}

	public CompanyBuilder() {
		super(new Company());
	}

	public Company build() {
		return getInstance();
	}
}

class CompanyBuilderBase<GeneratorT extends CompanyBuilderBase<GeneratorT>> {
	private Company instance;

	protected CompanyBuilderBase(Company aInstance) {
		instance = aInstance;
	}

	protected Company getInstance() {
		return instance;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withBaseImage(Set<BaseImage> aValue) {
		instance.setBaseImage(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withAddedBaseImageElement(BaseImage aValue) {
		if (instance.getBaseImage() == null) {
			instance.setBaseImage(new HashSet<BaseImage>());
		}

		((HashSet<BaseImage>) instance.getBaseImage()).add(aValue);

		return (GeneratorT) this;
	}

	public AddedBaseImageElementBaseImageBuilder withAddedBaseImageElement() {
		BaseImage obj = new BaseImage();

		withAddedBaseImageElement(obj);

		return new AddedBaseImageElementBaseImageBuilder(obj);
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withCompanyId(Long aValue) {
		instance.setCompanyId(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withCompanyName(String aValue) {
		instance.setCompanyName(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withAddressSet(Set<Address> aValue) {
		instance.setAddressSet(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withAddedAddressSetElement(Address aValue) {
		if (instance.getAddressSet() == null) {
			instance.setAddressSet(new HashSet<Address>());
		}

		((HashSet<Address>) instance.getAddressSet()).add(aValue);

		return (GeneratorT) this;
	}

	public AddedAddressSetElementAddressBuilder withAddedAddressSetElement() {
		Address obj = new Address();

		withAddedAddressSetElement(obj);

		return new AddedAddressSetElementAddressBuilder(obj);
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withAccepted(boolean aValue) {
		instance.setAccepted(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withVatNumber(String aValue) {
		instance.setVatNumber(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withKvkNumber(String aValue) {
		instance.setKvkNumber(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withUrl(String aValue) {
		instance.setUrl(aValue);

		return (GeneratorT) this;
	}

	public class AddedBaseImageElementBaseImageBuilder extends
			BaseImageBuilderBase<AddedBaseImageElementBaseImageBuilder> {
		public AddedBaseImageElementBaseImageBuilder(BaseImage aInstance) {
			super(aInstance);
		}

		@SuppressWarnings("unchecked")
		public GeneratorT endBaseImageElement() {
			return (GeneratorT) CompanyBuilderBase.this;
		}
	}

	public class AddedAddressSetElementAddressBuilder extends
			AddressBuilderBase<AddedAddressSetElementAddressBuilder> {
		public AddedAddressSetElementAddressBuilder(Address aInstance) {
			super(aInstance);
		}

		@SuppressWarnings("unchecked")
		public GeneratorT endAddressSetElement() {
			return (GeneratorT) CompanyBuilderBase.this;
		}
	}

	public static class AddressBuilderBase<GeneratorT extends AddressBuilderBase<GeneratorT>> {
		private Address instance;

		protected AddressBuilderBase(Address aInstance) {
			instance = aInstance;
		}

		protected Address getInstance() {
			return instance;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withAddressId(Long aValue) {
			instance.setAddressId(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withStreetName(String aValue) {
			instance.setStreetName(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withHouseNr(String aValue) {
			instance.setHouseNr(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withPostcode(String aValue) {
			instance.setPostcode(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withCity(String aValue) {
			instance.setCity(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withCountryCode(String aValue) {
			instance.setCountryCode(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withAccepted(boolean aValue) {
			instance.setAccepted(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withCompany(Company aValue) {
			instance.setCompany(aValue);

			return (GeneratorT) this;
		}

		public CompanyCompanyBuilder withCompany() {
			Company obj = new Company();

			withCompany(obj);

			return new CompanyCompanyBuilder(obj);
		}

		public class CompanyCompanyBuilder extends
				CompanyBuilderBase<CompanyCompanyBuilder> {
			public CompanyCompanyBuilder(Company aInstance) {
				super(aInstance);
			}

			@SuppressWarnings("unchecked")
			public GeneratorT endCompany() {
				return (GeneratorT) AddressBuilderBase.this;
			}
		}
	}

	public static class BaseImageBuilderBase<GeneratorT extends BaseImageBuilderBase<GeneratorT>> {
		private BaseImage instance;

		protected BaseImageBuilderBase(BaseImage aInstance) {
			instance = aInstance;
		}

		protected BaseImage getInstance() {
			return instance;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withProcesStatus(ProcesStatus aValue) {
			instance.setProcesStatus(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withUserInfo(UserInfo aValue) {
			instance.setUserInfo(aValue);

			return (GeneratorT) this;
		}

		public UserInfoUserInfoBuilder withUserInfo() {
			UserInfo obj = new UserInfo();

			withUserInfo(obj);

			return new UserInfoUserInfoBuilder(obj);
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withBaseImageId(Long aValue) {
			instance.setBaseImageId(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withCreationDate(Date aValue) {
			instance.setCreationDate(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withFileName(String aValue) {
			instance.setFileName(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withFileDirectory(String aValue) {
			instance.setFileDirectory(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withType(String aValue) {
			instance.setType(aValue);

			return (GeneratorT) this;
		}

		public class UserInfoUserInfoBuilder extends
				UserInfoBuilderBase<UserInfoUserInfoBuilder> {
			public UserInfoUserInfoBuilder(UserInfo aInstance) {
				super(aInstance);
			}

			@SuppressWarnings("unchecked")
			public GeneratorT endUserInfo() {
				return (GeneratorT) BaseImageBuilderBase.this;
			}
		}
	}

	public static class UserInfoBuilderBase<GeneratorT extends UserInfoBuilderBase<GeneratorT>> {
		private UserInfo instance;

		protected UserInfoBuilderBase(UserInfo aInstance) {
			instance = aInstance;
		}

		protected UserInfo getInstance() {
			return instance;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withBaseImage(Set<BaseImage> aValue) {
			instance.setBaseImage(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withAddedBaseImageElement(BaseImage aValue) {
			if (instance.getBaseImage() == null) {
				instance.setBaseImage(new HashSet<BaseImage>());
			}

			((HashSet<BaseImage>) instance.getBaseImage()).add(aValue);

			return (GeneratorT) this;
		}

		public AddedBaseImageElementBaseImageBuilder withAddedBaseImageElement() {
			BaseImage obj = new BaseImage();

			withAddedBaseImageElement(obj);

			return new AddedBaseImageElementBaseImageBuilder(obj);
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withUserId(Long aValue) {
			instance.setUserId(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withUserName(String aValue) {
			instance.setUserName(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withPassword(String aValue) {
			instance.setPassword(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withRole(String aValue) {
			instance.setRole(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withCreationDate(Date aValue) {
			instance.setCreationDate(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withLastLogin(Date aValue) {
			instance.setLastLogin(aValue);

			return (GeneratorT) this;
		}

		public class AddedBaseImageElementBaseImageBuilder extends
				BaseImageBuilderBase<AddedBaseImageElementBaseImageBuilder> {
			public AddedBaseImageElementBaseImageBuilder(BaseImage aInstance) {
				super(aInstance);
			}

			@SuppressWarnings("unchecked")
			public GeneratorT endBaseImageElement() {
				return (GeneratorT) UserInfoBuilderBase.this;
			}
		}
	}
}
